from rest_framework import serializers
from mosquito.models import Mosquito ,MosqPost
from smart.api.serializers import SmartListSerializer


class MosqListSerializer(serializers.ModelSerializer):

    class Meta:
        model = Mosquito
        fields = [
            'name',
            'device_id',
            'region'
        ]


class MosqPostListSerializer(serializers.ModelSerializer):
    region = serializers.SerializerMethodField()
    smarts = serializers.SerializerMethodField()

    class Meta:
        model = MosqPost
        fields = [
            'mosq',
            'led',
            'energy',
            'region',
            'smarts',
            'time',
        ]

    def get_region(self, obj):
        return obj.mosq.region

    def get_smarts(self, obj):
        smart_queryset = obj.mosq.smart_module.all()
        smarts = SmartListSerializer(smart_queryset, many=True).data
        return smarts
